/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * FinalizeDownloadFrame.java
 *
 * Created on Sep 9, 2011, 12:57:43 PM
 */
package download;

/**
 *
 * @author Cornel
 */
public class FinalizeDownloadFrame extends javax.swing.JFrame implements Runnable
{
    /** Creates new form FinalizeDownloadFrame */
    public FinalizeDownloadFrame()
    {
        initComponents();
        setTitle("Download");
        setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
        btnOk.setEnabled(false);
        Thread thr = new Thread(this);
        thr.start();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        lblDownload = new javax.swing.JLabel();
        pgrDownload = new javax.swing.JProgressBar();
        btnOk = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        btnOk.setText("OK");
        btnOk.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnOkActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(lblDownload, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 434, Short.MAX_VALUE)
                    .addComponent(pgrDownload, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, 434, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(19, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGap(208, 208, 208)
                .addComponent(btnOk)
                .addContainerGap(215, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addComponent(lblDownload, javax.swing.GroupLayout.PREFERRED_SIZE, 74, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(pgrDownload, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(btnOk)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private String formatedLabelText(String txt)
    {
        return "<html>"
            + txt.replaceAll(Download._newLine, "<br>")
            + "</html>";
    }

    private String formatedLabelText(String txt, String color)
    {
        return "<html>"
            + ((color == null) ? "" : "<font color=\"" + color + "\">")
            + txt.replaceAll(Download._newLine, "<br>")
            + ((color == null) ? "" : "</font>") + "</html>";
    }

    private void btnOkActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_btnOkActionPerformed
    {//GEN-HEADEREND:event_btnOkActionPerformed
        // TODO add your handling code here:
        Download._waitEvent.countDown();
        dispose();
    }//GEN-LAST:event_btnOkActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt)//GEN-FIRST:event_formWindowClosing
    {//GEN-HEADEREND:event_formWindowClosing
        // TODO add your handling code here:
        if(btnOk.isEnabled() == true)
        {
            Download._waitEvent.countDown();
            dispose();
        }
    }//GEN-LAST:event_formWindowClosing
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnOk;
    private javax.swing.JLabel lblDownload;
    private javax.swing.JProgressBar pgrDownload;
    // End of variables declaration//GEN-END:variables

    public void advanceProgressBar(int level, String text)
    {
        pgrDownload.setValue(level + 1);
        lblDownload.setText(text);
    }

    public void run()
    {
        String path = null;
        try
        {
            pgrDownload.setMinimum(0);
            pgrDownload.setMaximum(Download._dwn.size());
            pgrDownload.setValue(0);
            path = Download.downloadAll();
            if(path == null)
            {
                lblDownload.setText("Instalare fisiere downloadate");
                path = Download.finalizeDownload();
                if(path == null)
                {
//                JOptionPane.showMessageDialog(null, "Download terminat cu succes!");
                    lblDownload.setText(formatedLabelText("Instalare terminata cu succes!"
                        + ((Download._bckCreated == true) ? Download._newLine + Download._newLine + "Atentie! Fisierele de configurare vechi au fost salvate cu extensia .bck" : "")));
                }
                else
                {
//                JOptionPane.showMessageDialog(null, "Eroare finalizare descarcare:"
//                    + Download._newLine + path
//                    + Download._newLine + "Reluati procesul de descarcare");
                    lblDownload.setText(formatedLabelText("Eroare instalare programe descarcate:"
                        + Download._newLine + path
                        + Download._newLine + "Descarcati si instalati manual ultima versiune DUKIntegrator de pe site-ul ANAF", "red"));
                    Download._continuationFlag = false;
                }
            }
            else
            {
                Download.undoDownload();
//            JOptionPane.showMessageDialog(null, "Eroare descarcare:"
//                + Download._newLine + path
//                + Download._newLine + "Nu s-au instalat noile versiuni");
                lblDownload.setText(formatedLabelText("Eroare descarcare:"
                    + Download._newLine + path
                    + Download._newLine + "Nu s-au instalat noile versiuni", "red"));
            }
        }
        catch(Throwable ex)
        {
            lblDownload.setText(formatedLabelText("Eroare: " + ex.toString()
                + Download._newLine + path
                + Download._newLine + "Nu s-au instalat noile versiuni", "red"));
            Download._continuationFlag = false;
        }
        finally
        {
            Download.deleteCurrentVersionsFile();
            btnOk.setEnabled(true);
        }
    }
}
